options NOmlogic NOmprint NOspool;

filename Rptfile sasxbamw "&_MM_TaskDir./ReportVars.pdf" user="&_MM_User" pass="&_MM_Password";


goptions device=PDFC;
ods pdf file=Rptfile; 
TITLE "Common Reporting Macro Variables";
        DATA _NULL_;
           _MM_User = "&_MM_User";
           _MM_Password = "&_MM_Password";
           _MM_TaskDir = "&_MM_TaskDir";
           _MM_ReportLib = "&_MM_ReportLib";
           _MM_ResourcesLib = "&_MM_ResourcesLib";
           file print ods;
           put _ods_;
        RUN;

%macro process_models();
%put >>>>>>>>>>>>>>nModelObs = &nModelObs;
    %let endNdx=%eval(&nModelObs-1);
%put >>>>>>>>>>>>> endNdx = &endNdx;
    %do ndx=0 %to &endNdx;
%put >>>>>>>>>>>>> getting model &ndx;
        %getModelInfo(&ndx);
        
TITLE "Reporting Macro Variables for &_MM_ModelLabel";
        
        DATA _NULL_; 
           _MM_ModelLabel  = "&_MM_ModelLabel";
           _MM_TargetVar  = "&_MM_TargetVar";
           _MM_PosteriorVar  = "&_MM_PosteriorVar";
           _MM_TargetEvent  = "&_MM_TargetEvent";
           _MM_ScoreCodeType  = "&_MM_ScoreCodeType";
           _MM_ModelLib  = "&_MM_ModelLib";
           _MM_Input  = "&_MM_Input";
           _MM_Output  = "&_MM_Output";
           _MM_Target  = "&_MM_Target";
           _MM_Score  = "&_MM_Score";
           _MM_OutModel  = "&_MM_OutModel";
           _MM_InputLib  = "&_MM_InputLib";
           _MM_InputDS  = "&_MM_InputDS";
           _MM_OutputLib  = "&_MM_OutputLib";
           _MM_OutputDS  = "&_MM_OutputDS";
           _MM_PerformanceLib  = "&_MM_PerformanceLib";
           _MM_PerformanceDS  = "&_MM_PerformanceDS";
           _MM_TestLib  = "&_MM_TestLib";
           _MM_TestDS  = "&_MM_TestDS";
           _MM_TrainLib  = "&_MM_TrainLib";
           _MM_TrainDS  = "&_MM_TrainDS";
           FILE print ods;
           PUT _ods_;
        RUN;

        %closeLibsAndFiles();
    %end;
%mend process_models;

%getNumModelObs();

%process_models;

ods pdf close;
ods listing;
