import com.sas.modelmanager.td.Scoring;
import com.sas.modelmanager.td.Results;
import com.sas.tutorials.scoringapi.Loan;
import org.codehaus.groovy.grails.web.servlet.mvc.GrailsParameterMap;

class ScoreService {

    boolean transactional = false

    def String runScoring(GrailsParameterMap params) {

        if (params == null || params.isEmpty())
            return ""

        def projectUUID = "ProjectUUID"
        def host        = "HostName"
        def username    = "UserID"
        def password    = "Password"
        def database    = "DatabaseName"

        // We use the customer id (custid) to uniquely identify each record, so
        // pick up the passed in ID and set the whereClause to the value we need
        // for the scoring task to find the record we want. 

        def whereClause = "custid=${params.id}"


        // Now determine if the caller wants to set any dynamic predictors (i.e.,
        // values different from those stored in the columns for the specified
        // customer record.

        def loan = Loan.get( params.id ) // Get the requested record 
        def dynPred = ""

        if (params.bad && Double.valueOf(params.bad).doubleValue() != loan.bad?.doubleValue())
            dynPred += "BAD=${params.bad},"

        if (params.loan && Double.valueOf(params.loan).doubleValue() != loan.loan?.doubleValue())
            dynPred += "LOAN=${params.loan},"

        if (params.mortdue && Double.valueOf(params.mortdue).doubleValue() != loan.mortdue?.doubleValue())
            dynPred += "MORTDUE=${params.mortdue},"

        if (params.val && Double.valueOf(params.val).doubleValue() != loan.val?.doubleValue())
            dynPred += "\"VALUE\"=${params.val},"

        if (params.yoj && Double.valueOf(params.yoj).doubleValue() != loan.yoj?.doubleValue())
            dynPred += "YOJ=${params.yoj},"

        if (params.derog && Double.valueOf(params.derog).doubleValue() != loan.derog?.doubleValue())
            dynPred += "DEROG=${params.derog},"

        if (params.delinq && Double.valueOf(params.delinq).doubleValue() != loan.delinq?.doubleValue())
            dynPred += "DELINQ=${params.delinq},"

        if (params.clage && Double.valueOf(params.clage).doubleValue() != loan.clage?.doubleValue())
            dynPred += "CLAGE=${params.clage},"

        if (params.ninq && Double.valueOf(params.ninq).doubleValue() != loan.ninq?.doubleValue())
            dynPred += "NINQ=${params.ninq},"

        if (params.clno && Double.valueOf(params.clno).doubleValue() != loan.clno?.doubleValue())
            dynPred += "CLNO=${params.clno},"

        if (params.debtinc && Double.valueOf(params.debtinc).doubleValue() != loan.debtinc?.doubleValue())
            dynPred += "DEBTINC=${params.debtinc},"

        // Note that when sending strings to the database they must be enclosed
        // in single quotes.
        if (params.reason && loan.reason?.equals(params.reason) == false)
            dynPred += "REASON='${params.reason}',"

        if (params.job && loan.job?.equals(params.job) == false)
            dynPred += "JOB='${params.job}',"


        // Now strip off the last comma if one exists in the string which is the
        // case if the string is not empty.

        if ("".equals(dynPred) == false)
            dynPred = dynPred.substring(0,dynPred.length()-1)

        println("dynPred:${dynPred}")
        
        def Scoring scoring = new Scoring(host, username, password, database)
        def Results results = new Results(scoring.score(projectUUID, whereClause, dynPred))
        def score = results.get("score")

        println("score:${score}")

        return score
    }
}
